(**************************************************************************)
(*                                                                        *)
(*  SSH Authentication layer                                              *)
(*  Copyright (C) 2021   Peter Moylan                                     *)
(*                                                                        *)
(*  This program is free software: you can redistribute it and/or modify  *)
(*  it under the terms of the GNU General Public License as published by  *)
(*  the Free Software Foundation, either version 3 of the License, or     *)
(*  (at your option) any later version.                                   *)
(*                                                                        *)
(*  This program is distributed in the hope that it will be useful,       *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU General Public License for more details.                          *)
(*                                                                        *)
(*  You should have received a copy of the GNU General Public License     *)
(*  along with this program.  If not, see <http://www.gnu.org/licenses/>. *)
(*                                                                        *)
(*  To contact author:   http://www.pmoylan.org   peter@pmoylan.org       *)
(*                                                                        *)
(**************************************************************************)

IMPLEMENTATION MODULE AuthLayer;

        (********************************************************)
        (*                                                      *)
        (*              Authentication layer of SSH             *)
        (*                                                      *)
        (*  Programmer:         P. Moylan                       *)
        (*  Started:            29 May 2021                     *)
        (*  Last edited:        27 November 2021                *)
        (*  Status:             Dummy module                    *)
        (*                                                      *)
        (*  This module is not used by the client software at   *)
        (*  all, but has to be present to satisfy the compiler. *)
        (*  That is because the TransportLayer module is        *)
        (*  common to the server and client programs, and it    *)
        (*  contains a call to AuthLayer.NewSession (which,     *)
        (*  however, is invoked only in server code).           *)
        (*                                                      *)
        (********************************************************)


FROM PacketIO IMPORT IOPort;
FROM PacketQueues IMPORT PacketQ;
FROM TransLog IMPORT TransactionLogID;

(************************************************************************)
(*                THE AUTHENTICATION SESSION TASK CODE                  *)
(*    which is a dummy, because authentication is a server function     *)
(************************************************************************)

PROCEDURE NewSession (sshport: IOPort;  Q: PacketQ;  ID: TransactionLogID): BOOLEAN;

    (* A dummy procedure which has to be linked in but which is *)
    (* never executed.                                          *)

    BEGIN
        RETURN FALSE;
    END NewSession;

(************************************************************************)

END AuthLayer.

