:userdoc.
:title.SFTPClient documentation
:docprof toc=123.

.***********************************
.*   INTRODUCTION
.***********************************

:h1 res=1000 id=1000 global.Introduction

:p.This package is a command-line SFTP client, similar to an FTP client but using an encrypted
transmission channel.

:p.This is an early-release version, so that you can get a feel for what the final
product will look like. Some features are still missing.

:p.The author of this package is Peter Moylan, peter@pmoylan.org.

.***********************************
.*   RUNNING THE PROGRAM
.***********************************

:h1 id=running.Running the program
:hp2.Running the program:ehp2.

:p.You can run the SFTP client with the command
:xmp.
      sftp hostname
:exmp.
or
:xmp.
      sftp username@hostname
:exmp.

:p.If you don't specify a username you will be prompted for one. There will
be a delay of a few seconds before the connection is complete, because the
behind-the-scenes negotiation of what encryption algorithms and parameters to
use are rather time-consuming.

:p.Once logged in, the commands you can use are listed on the
:link reftype=hd refid=projectstatus.project status:elink. page.

.***********************************
.*   PROJECT STATUS
.***********************************

:h1 id=projectstatus.Overall project status
:hp2.Overall project status:ehp2.

:p.The encryption substrate is an implementation of the secure shell SSH. This is working.

:p.The implementation status of the individual commands is listed below.
Summary&colon. we have an almost-complete implementation, but some minor features are still missing.

:p.:hp2.Already working:ehp2.

:p.The following SFTP commands are working, subject to further testing.
:dl compact tsize=25 break=fit.
:dt. ?
:dd.a synonym for help
:dt. bye
:dd.synonym for exit
:dt. cd :hp1.path:ehp1.
:dd.change remote directory
:dt. del :hp1.path:ehp1.
:dd.synonym for delete
:dt. delete :hp1.path:ehp1.
:dd.delete a remote file
:dt. dir
:dd.remote directory listing, long form
:dt. exit
:dd.exit from program
:dt. get :hp1.remote-path:ehp1.
:dd.download a file
:dt. help
:dd.show a list of commands
:dt. lcd :hp1.path:ehp1.
:dd.change local directory
:dt. ldel :hp1.path:ehp1.
:dd.synonym for ldelete
:dt. ldelete :hp1.path:ehp1.
:dd.delete local file or directory
:dt. ldir
:dd.local directory listing, long form
:dt. lls
:dd.local directory listing, short form
:dt. lmkdir :hp1.path:ehp1.
:dd.create local directory
:dt. lpwd
:dd.show name of local directory
:dt. lrm :hp1.path:ehp1.
:dd.synonym for ldelete
:dt. ls
:dd.remote directory listing, short form. The usual Unix options are not yet supported.
:dt. mkdir :hp1.path:ehp1.
:dd.create remote directory
:dt. put :hp1.local-path:ehp1.
:dd.upload a file
:dt. pwd
:dd.show name of remote directory
:dt. quit
:dd.synonym for exit
:dt.ren :hp1.path1:ehp1. :hp1.path2:ehp1.
:dd.synonym for rename
:dt.rename :hp1.path1:ehp1. :hp1.path2:ehp1.
:dd.rename a file or directory
:dt. rm :hp1.path:ehp1.
:dd.synonym for delete
:dt.rmdir :hp1.path:ehp1.
:dd.delete a remote directory
:dt. version
:dd.displays the SFTP version number.
:edl.

:p.:hp2.Not yet working:ehp2.

:p.The following commands are not implemented or not working.
:ul.
:li.reget remote-path - resume an incomplete download
:li.reput local-path - resume an incomplete upload
:eul.

:p.:hp2.Unsupported:ehp2.

:p.The following commands will probably never be implemented, as they are inconsistent
with the FtpServer file system model. In the FTPServer model, only the system manager
may control ownership, permissions, and links.

:ul compact.
:li.chgrp: change group
:li.chmod: change permissions.
:li.chown: change owner.
:li.ln: create a link.
:li.lumask: set a mask.
:li.symlink: create a symbolic link
:eul.

.***********************************
.*   KNOWN BUGS
.***********************************

:h1 id=bugs.Known bugs
:hp2.Known bugs:ehp2.

:ul.
:li.Sometimes crashes on exit, possibly because of messages still in transit.
:eul.


:euserdoc.

